<?php
/* SVN FILE: $Id: app_controller.php 4409 2007-02-02 13:20:59Z phpnut $ */
/**
 * Short description for file.
 *
 * This file is application-wide controller file. You can put all
 * application-wide controller-related methods here.
 *
 * PHP versions 4 and 5
 *
 * CakePHP(tm) :  Rapid Development Framework <http://www.cakephp.org/>
 * Copyright 2005-2007, Cake Software Foundation, Inc.
 *								1785 E. Sahara Avenue, Suite 490-204
 *								Las Vegas, Nevada 89104
 *
 * Licensed under The MIT License
 * Redistributions of files must retain the above copyright notice.
 *
 * @filesource
 * @copyright		Copyright 2005-2007, Cake Software Foundation, Inc.
 * @link				http://www.cakefoundation.org/projects/info/cakephp CakePHP(tm) Project
 * @package			cake
 * @subpackage		cake.cake
 * @since			CakePHP(tm) v 0.2.9
 * @version			$Revision: 4409 $
 * @modifiedby		$LastChangedBy: phpnut $
 * @lastmodified	$Date: 2007-02-02 07:20:59 -0600 (Fri, 02 Feb 2007) $
 * @license			http://www.opensource.org/licenses/mit-license.php The MIT License
 */
/**
 * This is a placeholder class.
 * Create the same file in app/app_controller.php
 *
 * Add your application-wide methods in the class below, your controllers
 * will inherit them.
 *
 * @package		cake
 * @subpackage	cake.cake
 */
class AppController extends Controller {
	var $hmenus = array();
	var $submenus = array();
	
	//wangs start 20080227
	var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv');  
    var $components = array ('Pagination', 'Lv');
    //xinw start 20080505
    var $uses=array('Host','Poll','Grpshd','Group');
    //xinw end 20080505
    //wangs end 20080227
	
	var $allowedaction = array();
    
	function beforeFilter()
	{
		if($this->name != 'App'){
			if(in_array($this->params['action'], $this->allowedaction)){
				return;
			}
			if(!$this->checkLogin()){
				//登録しない










				$this->render();
				exit;
			}
			if(isset($this->replacedName)){
				$temp_controller_name = $this->params['controller'];
				$this->params['controller'] = $_GET['url'] = $this->replacedName;			//add by wzy at 20071119 for NetMetrixes Authority))
			}
			$this->authByLic();
			$this->authByUser();
			if(isset($this->replacedName)){
				$this->params['controller'] = $_GET['url'] = $temp_controller_name;			//add by wzy at 20071119 for NetMetrixes Authority))
			}
		}
	}
	function allow($action)
	{
		$this->allowedaction[] = $action;
	}
	function afterFilter()
	{
		
	}
	
	function beforeRender()
	{ 
		if($this->viewPath == 'errors')
			return;
			
		$this->set('isSoten', 1);
		$this->setMenu();
		$user = $this->_getUser();
		$this->set('user_name', $user['user_name']);
		
		//wangs start 20080227
		$Hosts= $this->Host->findAll(null, null, null,null,null,-1);

		$Polls= $this->Poll->findAll('poll_name is not null', null, null,null,null,-1);

		$Grpshds= $this->Grpshd->findAll(null, null, null,null,null,-1);

		if (count($Hosts)>0 && count($Polls)>0 && count($Grpshds)>0) {
			$init_finished=true;
		}else {
			$init_finished=false;
		}
		$this->set('init_finished', $init_finished);
		//wangs end 20080227
		//xinw start 20080505
		$grp_shd=$this->Group->query('select count(*) from groups G where NOT EXISTS (select * from grpshds S where S.group_id = G.id)');
		$count_grp_shd=$grp_shd[0][0]['count(*)'];
		$this->set('count_grp_shd', $count_grp_shd);
		//xinw end 20080505
	}

    function setMenu()
    {
    	$url = explode("/", $_GET['url']);
    	if($url[0] == 'login' && isset($url[2])){
    		$this->set('menu', $url[2]);
    		$this->set('submenu', NULL);
    		return;
    	}
		@list($menu, $submenu) = explode('_', $url[0]);
		$this->set('menu', $menu);
		$this->set('submenu', $submenu);
		isset($this->params['controller']) ? $this->set("controller_name", strtolower($this->params['controller'])) : null;
		isset($this->params['action']) ? $this->set("action_name", strtolower($this->params['action'])) : null;
    }
    
    function authByLic()
    {
		$this->uses[] = "Someauth";
		$this->constructClasses();
    	$md5 = md5(strtolower($this->params['controller']) . "tail");
    	$controllers = $this->Someauth->findAll(array("Someauth.authoritied" => $md5));
    	if(empty($controllers)){
    		//not be licenced
    		exit;
    	}
    }
    
    function authByUser()
    {
    	$this->uses[] = "Rltuserauth"; 
		$this->constructClasses();
		//このController Authority認証
    	$authoritied = $this->_get_auth(array(strtolower($this->params['controller'])));
		if(!empty($authoritied)){
			//認証OK
			$this->_to_set_hmenu();
    		//submenu for the controller itself 
    		$url = explode('/', $_GET['url']);
    		$url = explode('_', $url[0]);
    		/*$func = "_submenu_" . $url[0];
    		if($func != '_submenu_psauths'){
    			$this->$func();
    		}*/
			$this->_to_set_submenu();
    	}
    	else {
    		exit;
    	}
    }
	
	function _to_set_submenu()
	{	
		$this->_submenu_system();
		$this->_submenu_manage("assets_");
		$this->_submenu_manage("oper_");
		$this->_submenu_manage("use_");
		$this->_submenu_manage("alerts_");
		$this->_submenu_manage("uptime_");
		$this->_submenu_manage("remote_");
		$this->_submenu_manage("opt_");
		$this->_submenu_manage("attendance_");
	}
    
	function checkLogin()
	{
		$user = $this->_getUser();
		if(empty($user)){
			if($this->name != 'Login'){
				$this->redirect('/login/');
			}
			return false;
		}
		else {
			return true;
		}
	}
    
	function addModel()
	{
		$models = func_get_args();
		foreach ($models as $v)
		{
			$this->uses[] = $v;
		}
		$this->constructClasses();
	}
	
    function _get_auth($like = NULL, $notlike = NULL)
    {
    	$this->set('notSoten', 1);
    	$criteria = array("Rltuserauth.user_id = " . $this->_getUserId());
    	if(!empty($like)){
    		foreach ($like as $v){
    			$criteria[] = "Authority.controller_name LIKE '" . $v . "'"; 
    		}
    	}
    	if(!empty($notlike)){
    		foreach ($notlike as $v){
    			$criteria[] = "Authority.controller_name NOT LIKE '" . $v . "'"; 
    		}
    	}
    	$authoritied = $this->Rltuserauth->findByAsso($criteria, 
    													array('Rltuserauth.authority_id', 'Authority.controller_name'), null, null, null, 
    													array("Authority : authorities" => array("Rltuserauth.authority_id = Authority.id"))
    												);
    	return $authoritied;
    }
    function _to_set_hmenu()
    {
    	//xinw start 20080703
		$this->_destroy_menu_session();
    	//if( ! $this->_set_hmenus_by_session('hmenus')){
    	//xinw end 20080703
			//head menu set
			$this->_isset_hmenu("assets_");
			$this->_isset_hmenu("oper_");
			$this->_isset_hmenu("use_");
			$this->_isset_hmenu("alerts");
			$this->_isset_hmenu("securities");
			$this->_isset_hmenu("system_");
			$this->_isset_hmenu("opt_");
			//jinl start 20080331
			$this->_isset_hmenu("opu_");
			//jinl end 20080331
			$this->_isset_hmenu("assets_netscan");
			$this->_isset_hmenu("uptime_");
			$this->_isset_hmenu("remote_");
			$this->_isset_hmenu("attendance_");
			$this->_set_hmenus_to_session('hmenus');
			// change by 20080101 zhangs
    	//xinw start 20080703
    	//}
    	//xinw end 20080703
    }
    function _isset_hmenu($head, $nohead = NULL)
    {
    	empty($nohead) ? 
    			$authoritied = $this->_get_auth(array($head . "%"))
    			: $authoritied = $this->_get_auth(array($head . "%"), array($nohead . "%"));
    	if(!empty($authoritied)){
    		$this->hmenus[] =$head;
    		$this->set($head, 1);
    	}
    }
    function _set_hmenus_to_session($head)
    {
    	if(!empty($this->hmenus)){
			$this->Session->write($head, $this->hmenus);
			$this->head = array();	//clear the value;
    		return true;
    	}
    	else {
    		return false;
    	}
    }
    function _add_hmenus_to_session($head)
    {
    	if(!empty($this->$head)){
    		$head_v = $this->Session->read($head);
    		if(!empty($head_v)){
    			$this->Session->write($head, array_merge($head_v, $this->$head));
    		}
    		else {
    			$this->Session->write($head, $this->$head);
    		}
    		return true;
    	}
    	else {
    		return false;
    	}
    }
    function _set_hmenus_by_session($head)
    {
    	$menus = $this->Session->read($head);//var_dump($head);
    	if(empty($menus)){
    		return false;
    	}
    	else{
    		foreach($menus as $head){
    			$this->set($head, 1);;
    		}
    		return true;
    	}
    }
    function _destroy_menu_session()
    {
    	$this->Session->delete("hmenus");
    	$this->Session->delete("hmenus-system");
    	$this->Session->delete("submenus");
    	$this->Session->delete("submenus-use_");
    	$this->Session->delete("submenus-assets_");
    	$this->Session->delete("submenus-oper_");
    	$this->Session->delete("submenus-system_");
    		// change by 20080201 zhangs
    	$this->Session->delete("submenus-opt_");
    	//jinl start 20080331
		$this->Session->delete("submenus-uptime_");
		$this->Session->delete("submenus-remote_");
    	$this->Session->delete("submenus-opu_");
		$this->Session->delete("submenus-attendance_");
    	//jinl end 20080331
    }
    function _submenu_assets()
    {
    	$this->_submenu_manage("assets_");
    }
    function _submenu_oper()
    {
    	$this->_submenu_manage("oper_");
    }
    function _submenu_use()
    {
    	$this->_submenu_manage("use_");
    }
    function _submenu_alerts()
    {
    	return true;
    }
    // change by 20080201 zhangs
    function _submenu_opu()
    {
    	$this->_submenu_manage("opu_");
    }
    //change by 20080328 jinl
    function _submenu_securities()
    {
    	return true;
    }
    function _submenu_alert()
    {
    	return true;
    }
	function _submenu_netscan()
    {
    	$this->_submenu_manage("assets_netscan_");
    }
    // change by 20080201 zhangs
    function _submenu_opt()
    {
    	$this->_submenu_manage("opt_");
    }
	function _submenu_uptime()
    {
		$this->addModel("Employeeaccount");
		$not_exist=$this->Employeeaccount->query('select count(*) from employeeaccounts where exist=0');
    	$this->set('not_exist', $not_exist[0][0]['count(*)']);
		$this->_submenu_manage("uptime_");
    }
	function _submenu_attendance()
    {
		$this->_submenu_manage("attendance_");
    }
	function _submenu_remote()
    {
		$this->_submenu_manage("remote_");
    }
    function _submenu_manage($head)
    {
    	if( ! $this->_set_hmenus_by_session('submenus-' . $head)){
	    	$authoritied = $this->_get_auth(array($head . "%"));
	    	foreach($authoritied as $v){
	    		$this->set("submenu_" . $v['Authority']['controller_name'], 1);
	    		$this->hmenus[] = "submenu_" . $v['Authority']['controller_name'];
	    	}
		    $this->_set_hmenus_to_session('submenus-' . $head);
    	}
    }
    function _submenu_system()
    {
    	$this->_submenu_manage("system_");
    	//xinw start 20080703
    	//if( ! $this->_set_hmenus_by_session('hmenus-system')){
    	//xinw end 20080703
	    	$this->_isset_hmenu("system_all_");
	    	$this->_isset_hmenu("system_grpset_", "system_grpset_alert_");
	    	$this->_isset_hmenu("system_grpset_alert_");
	    	$this->_isset_hmenu("system_monitor_");
	    	$this->_isset_hmenu("system_userinfos");
		    $this->_set_hmenus_to_session('hmenus-system');
		     // zhangs start 20080201
			$this->_isset_hmenu("system_folder_");
			// zhangs end 20080201
    	//xinw start 20080703
    	//}
    	//xinw end 20080703
    }
    function _submenu_login()
    {
    	$this->_submenu_manage("system_");
    }
	function _getUser()
	{
		$user = $this->Session->read('user');
		if(empty($user)){
//			$user = array();
//			$user['id'] = 2;
//			$user['user_name'] = 'So-ten'; 
		}
		else {
			$this->set('isSoten', 0);
		}
		return $user;
	}
	function _getUserId()
	{
		$user = $this->_getUser();
		return $user['id'];
	}
	function _getUserGroup()
	{
		$user = $this->_getUser();
		return $user['group_id'];
	}
	
	function isAdmin()
	{
		if($this->_getUserGroup() == 1){
			$this->set("isAdmin", true);
			return true;
		}
		else {
			$this->set("isAdmin", false);
			return false;
		}
	}
}
?>