<?php
class AttendanceViewController extends AppController
{
	var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv', 'Cache');
	var $components = array ('Pagination', 'Lv','Check','GenerateFiles');
	var $uses=array('Group', 'Host', 'Rlthstgrp','Grpauth', 'Authority','Rltuserauth','User','Configure','Validation',
	'Employee', 'Seatlayout', 'Siteinfo', 'Hstattendance', 'Workstatus', 'Draftlayout');
	var $layout='attendview';
	
	var $cacheAction = array("attendance_view/status"  => "10 seconds");
								
	function beforeFilter()
	{
	//	parent::beforeFilter();
		$this->pageTitle =__('menu_uptime',$retrun=true); 
		if(isset($_POST['forHideVar'])){
			$this->set('forHideVar', $_POST['forHideVar']);
		}
		elseif(isset($_POST['forHideVar1'])){
			$this->set('forHideVar', $_POST['forHideVar1']);
		}
	}
	
	//////////レイアウト編集
	function index($siteid=null,$draftid=null)
	{
		$this->pageTitle =__('title',$return = true);
		
		$sites = $this->Siteinfo->findAll(null,null,"showorder ASC");
		$keys = Set::extract($sites, '{n}.Siteinfo.id');
		$vals = Set::extract($sites, '{n}.Siteinfo.site_name');
		$slist = array_combine($keys, $vals);
		//$slist['']="";
		//ksort($slist);
		$this->set('slist',$slist);
		
		$status = $this->Workstatus->findAll(null, array("Workstatus.name","Workstatus.forecolor","Workstatus.backcolor"),"id ASC");
		$this->set('status',$status);
		
		
		$criteria[] = "Siteinfo.defview = 1";
		$defsite = $this->Siteinfo->find($criteria, "id");
		if(!empty($defsite)){
			$this->set('siteid',$defsite['Siteinfo']['id']);
			$this->data['site']['select'] = $defsite['Siteinfo']['id'];
			$this->set('draft', 0);
		}
		
		if(!is_null($siteid)){
			$this->set('siteid',$siteid);
			$this->data['site']['select'] = $siteid;
			$this->set('draft', $draftid);
		}
		
		$dir=DATABASE_PATH."\\..\\custom.ini";
		$ini_array = parse_ini_file($dir,true);
		if (!empty($ini_array)) {
			if (isset($ini_array['Manual']['link_title'])) {
				$this->set('link_title', $ini_array['Manual']['link_title']);
			}
			if (isset($ini_array['Manual']['link_url'])) {
				$this->set('link_url', $ini_array['Manual']['link_url']);
			}
		}
			
		
		$this->render('index');
	}
	
	function layout($site_id)
	{
		$this->layout="attendance";
		$this->set('siteid', $site_id);
	}
	
	function search($site_id=1)
	{
		$this->layout="";
		
		$draft= json_decode($_POST['draft']);
		
		$asso = array(
			'Employee : employees : LEFT' => array('Employee.id = Seatlayout.emp_id')
		) ;
		if($draft > 0){
			$asso['Draftlayout : draftlayouts : LEFT'] = array(
				'Seatlayout.id = Draftlayout.seat_id', 
				'Seatlayout.site_id = Draftlayout.site_id',
				"Draftlayout.draft_id = ".$draft
				);
		}
		
		//取得項目
		$fields = array(
			'Seatlayout.id as id',
			'Employee.id as eid',
			'Employee.id_name as idname',
			'Employee.name as ename',
			'Employee.name_eng as nameeng',
			'Employee.linenumber as line',
			'Seatlayout.name as iname',
			'Seatlayout.itemcolor as icolor',
			'Seatlayout.bordercolor as bcolor',
			'Seatlayout.size_x as size_x',
			'Seatlayout.size_y as size_y',
			'Seatlayout.linestyle as linestyle',
		);
		if($draft > 0){
			$fields[] = '(case when Draftlayout.pos_x is null then -1 else Draftlayout.pos_x end) as pos_x';
			$fields[] = '(case when Draftlayout.pos_y is null then -1 else Draftlayout.pos_y end) as pos_y';
		}else{
			$fields[] = 'Seatlayout.pos_x as pos_x';
			$fields[] = 'Seatlayout.pos_y as pos_y';
		}
		$criteria = array("1=1");
		$criteria[]="Seatlayout.site_id = ".$site_id;

		//取得
		$Seatlayout = $this->Seatlayout->findByAsso($criteria, $fields, null, null, null, $asso);
		//exit;
		header("Content-Type: application/json; charset=utf-8");
		$json = json_encode( $Seatlayout ) ;
		$this->set(compact('json'));
	}
	
	function status($siteid)
	{
		$this->layout="ajax";
		
		//ステータスの取得
		$asso = array(
			'Employee : employees' => array('Employee.id = Seatlayout.emp_id'),
			'Employeeaccount : employeeaccounts' => array('Employee.id = Employeeaccount.employee_id','Employeeaccount.number = 0'),
			'Host : hosts' => array('Host.id = Employeeaccount.host_id'),
			'Hstattendance : hstattendance' => array('Host.id = Hstattendance.host_id'),
			'Workstatus : workstatus' => array('Workstatus.id = Hstattendance.status'),
			'Siteinfo : siteinfo' => array('Siteinfo.id = Seatlayout.site_id')		
		) ;
		
		//取得項目
		$fields = array(
			'Seatlayout.id as id',
			'Hstattendance.status as status',
			'TIMESTAMPDIFF(MINUTE, Hstattendance.lasttime, now()) as minutes',
			'Workstatus.backcolor as bcolor',
			'Workstatus.forecolor as fcolor',
			'Workstatus.name as name'
		);

		$criteria = array("1=1");
		$criteria[]="Seatlayout.site_id = ".$siteid;
		$criteria[]="Employee.status = 1";//有効な従業員

		//取得
		$status = $this->Seatlayout->findByAsso($criteria, $fields, null, null, null, $asso);
//var_dump($Seatlayout);
		header("Content-Type: application/json; charset=utf-8");
		$json = json_encode( $status ) ;
		$this->set(compact('json'));
	}
}
?>