<?php
class UptimeRecordsController extends AppController
{
	var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv');
	var $components = array ('Pagination', 'Lv','Check');
	var $uses=array('Group', 'Host','Rlthstgrp','Grpauth','Hstalt','Authority','Rltuserauth','User','Configure','Validation',
	'Employee','Employeeaccount', 'Employeeadacc', 'Optuser', 'Timecontrol','Hstactivelog');
	var $layout='uptime';
	function beforeFilter()
	{
		parent::beforeFilter();
		$this->pageTitle =__('menu_uptime',$retrun=true); 
		if(isset($_POST['forHideVar'])){
			$this->set('forHideVar', $_POST['forHideVar']);
		}
		elseif(isset($_POST['forHideVar1'])){
			$this->set('forHideVar', $_POST['forHideVar1']);
		}
	}
	function index($errorMessage = null)
	{
		$glist = $this->Grpauth->getChildrenByParent($this->_getUserGroup());
		ksort($glist);
		$this->set('glist',$glist);
		
				//グループ所属の社員ID
		$group_ids = "";
		foreach($glist as $key => $g){
			$group_ids .= $key.",";
		}
		$group_ids = rtrim($group_ids, ","); 
		$fields = array('Employee.id', 
		'concat(Employee.id_name, " ", Employee.name) as Employee__name', 
		'Employee.id_name');
		$criteria[]="Employee.group_id in (".$group_ids.")";
		$elist = $this->Employee->findAll($criteria, $fields, "Employee.id_name", null, 1);
		if(!empty($elist)){
			$keys = Set::extract($elist, '{n}.Employee.id');
			$vals = Set::extract($elist, '{n}.Employee.name');
			$elist = array_combine($keys, $vals);
		}
		$elist = array(""=>"全て") + $elist;
		//debug($elist);
		$this->set('elist',$elist);
	}
	
	function search_($type=null)
	{
		$this->layout="ajax";
		//debug($this->data);
		$group_id = $this->data['Employee']['group_id'];
		$emp_id = $this->data['Employee']['id'];
		
		$criteria[] = "1=1";
		
		//開始時間、時間外の判定
		$defaults = $this->getDefault($group_id);
		//debug($defaults);
		$times = "";
		foreach($defaults as $gid => $def){
			$start = "00:00:00";
			if(!empty($def['Timecontrol']['start_day']))
				$start = $def['Timecontrol']['start_day'];
			$by_dt = $this->Lv->optionsDatetime4($start);
			$time = implode(' and ', $by_dt)." and (Employee.group_id = ".$gid." or Employeead.group_id = ".$gid.")";
			$times .= "(".$time.") or";
		}
		$times = rtrim($times, "or"); 
		if(strlen($times) > 0)
			$criteria[] = "(".$times .")";
		else
			$criteria[] = "1=2";
		
	/*	$start = "00:00:00";
		$by_dt = $this->Lv->optionsDatetime4($start);
		//debug($by_dt);
		$criteria[] = implode(' and ', $by_dt);*/
		
		$glist = $this->Grpauth->getChildrenByParent($group_id);
		$group_ids = "";
		foreach($glist as $key => $g){
			$group_ids .= $key.",";
		}
		$group_ids = rtrim($group_ids, ","); 
		$criteria[] = "(Employee.group_id in (". $group_ids.") or Employeead.group_id in (". $group_ids."))";

		
		if(!empty($emp_id))
			$criteria[] = "(Employee.id =". $emp_id." or Employeead.id =". $emp_id.")";
		//$criteria[] = "(Employeeaccount.account is null OR Employeeaccount.account = Optuser.account)";
		$criteria[] = "Optuser.log_status in (0,1,2)";
		$criteria[] = "Optuser.AccessFrom = ''";
		$criteria['GROUP BY'] = "Optuser.host_id, Optuser.account, Optuser.domain, DATE_FORMAT(SUBTIME(Optuser.tslog, '$start'), '%Y%m%d')";
		//Optuser.log_status, 
		$asso = array(
		'Host : hosts' => array('Optuser.host_id = Host.id'),
		'Employeeaccount : employeeaccounts : left' => array(
			'Employeeaccount.host_id = Optuser.host_id',
			'Employeeaccount.account = Optuser.account'),
		'Employee : employees : left' => array('Employeeaccount.employee_id = Employee.id'),
		'Group : groups : left' => array('Group.id = Employee.group_id'),
		//ad
		//'Employeeadacc : employeeadaccs : left' => array('Employeeadacc.account = Optuser.account'),
		'Employeeadacc : employeeadaccs : left' => array(
			"Employeeadacc.account like concat(Optuser.domain,'%\\\',Optuser.account)"),
		'Employeead : employees : left' => array('Employeeadacc.employee_id = Employeead.id'),
		'Groupad : groups : left ' => array('Groupad.id = Employeead.group_id'),

		);
		//0:logoffex 1:logon 2:logoff
		$fields = array(
		'date(min(Optuser.tslog)) as Optuser__date',
		'min(case when log_status = 1 then Optuser.tslog else "9999-01-01 00:00:00" end) as Optuser__in_min',
		'max(case when log_status = 2 or log_status = 0 then Optuser.tslog else "1000-01-01 00:00:00" end) as Optuser__out_max',
	'max(case when log_status = 1 then Optuser.tslog else "1000-01-01 00:00:00" end) as Optuser__in_max',
	'min(case when log_status = 2 or log_status = 0 then Optuser.tslog else "9999-01-01 00:00:00" end) as Optuser__out_min',	//	'Group.group_name as Group__group_name',
		'(case when Group.group_name is null then Groupad.group_name else Group.group_name end) as Group__group_name',
		'Host.host_name as Host__host_name',
		'Host.id as Host__id',
	'sum(case when log_status = 1 then 1 else 0 end) as Optuser__in_count',
	'sum(case when log_status = 2 or log_status = 0 then 1 else 0 end) as Optuser__out_count',

	//	'Optuser.account as Optuser__account',
		'(case when Employeeadacc.account is null then Optuser.account else Employeeadacc.account end) as Optuser__account',
	//	'Employee.id_name as Employee__id_name',
	//	'Employee.name as Employee__name',
		'(case when Employee.id_name is null then Employeead.id_name else Employee.id_name end) as Employee__id_name',
		'(case when Employee.name is null then Employeead.name else Employee.name end) as Employee__name',
		'(case when Employee.group_id is null then Employeead.group_id else Employee.group_id end) as Employee__group_id',
		);
		//$this->Pagination->show = 1;//100
		if($type=='csv'){
			$data = $this->Optuser->findByAsso($criteria, $fields, 'Optuser__date, Group.group_name, Employee__id_name, Host.host_name', null, null, $asso);
		}else{
			list($order,$limit,$page) = $this->Pagination->init($criteria, null, array('ajaxDivUpdate'=>'search', 'url'=>'/uptime_records/search/', 'modelClass'=>'Optuser', 'queryType' => array('function' => 'findByAsso', 'asso' => $asso), 
			'sortBy' => $this->Lv->sortBy('Optuser__date, Group.group_name, Employee__id_name, Host.host_name')));

			$log_count = $this->Pagination->paging['total'];
			$log_limit = 5000;
			$dir=LOG_LIMIT;
			$ini_array = parse_ini_file($dir,true);
			if (!empty($ini_array) && ereg("^[0-9]{1,}$",$ini_array['LogLimit']['Log_timekeeper'])) {
				$log_limit = $ini_array['LogLimit']['Log_timekeeper'];
			}
			if($log_count > $log_limit){
				$this->set('count_err',__("E-03900",true).$log_limit.__("E-03900-1",true));
				$this->render();
				exit();
			}			
						
			$data = $this->Optuser->findByAsso($criteria, $fields, $order, $limit, $page, $asso);

		}
		
		//debug($data);
		$data2 = array();
		$week = array("日", "月", "火", "水", "木", "金", "土");
		foreach($data as $record){
			$tmp = $record;
            //最初がログイン
			if( $tmp['Optuser']['in_min'] <= $record['Optuser']['out_min']){
				//最後がログアウト
				if($tmp['Optuser']['in_max'] < $record['Optuser']['out_max']){
					if($tmp['Optuser']['in_count'] > $record['Optuser']['out_count']){//ログインが多い
						$tmp['Optuser']['start'] = date('H:i', strtotime($record['Optuser']['in_min']));
						$tmp['Optuser']['start_long'] = $record['Optuser']['in_min'];
						$tmp['Optuser']['end'] = "";
					}else if($tmp['Optuser']['in_count'] < $record['Optuser']['out_count']){//ログアウトが多い
						$tmp['Optuser']['start'] = "";
						$tmp['Optuser']['end'] = date('H:i', strtotime($record['Optuser']['out_max']));
						$tmp['Optuser']['end_long'] = $record['Optuser']['out_max'];
					}else{//同じ
						$tmp['Optuser']['start'] = date('H:i', strtotime($record['Optuser']['in_min']));
						$tmp['Optuser']['start_long'] = $record['Optuser']['in_min'];
						$tmp['Optuser']['end'] = date('H:i', strtotime($record['Optuser']['out_max']));
						$tmp['Optuser']['end_long'] = $record['Optuser']['out_max'];
					}
				}else{ //最後がログイン
					if($tmp['Optuser']['in_count'] > $record['Optuser']['out_count']){//ログインが多い
						$tmp['Optuser']['start'] = date('H:i', strtotime($record['Optuser']['in_min']));
						$tmp['Optuser']['start_long'] = $record['Optuser']['in_min'];
						$tmp['Optuser']['end'] = "";
					}else if($tmp['Optuser']['in_count'] < $record['Optuser']['out_count']){//ログアウトが多い
						$tmp['Optuser']['start'] = "";
						$tmp['Optuser']['end'] = "";
					}else{//同じ
						$tmp['Optuser']['start'] = "";
						$tmp['Optuser']['end'] = "";
					}
				}
							
			}else{//最初がログアウト
				$tmp['Optuser']['start'] = "";
				$tmp['Optuser']['end'] = "";
				//最後がログアウト
				if($tmp['Optuser']['in_max'] < $record['Optuser']['out_max']){
					if($tmp['Optuser']['in_count'] < $record['Optuser']['out_count']){//ログアウトが多い
						$tmp['Optuser']['end'] = date('H:i', strtotime($record['Optuser']['out_max']));
						$tmp['Optuser']['end_long'] = $record['Optuser']['out_max'];
					}
				}
			}
			/*
			if($record['Optuser']['in_min'] == "9999-01-01 00:00:00")
				$tmp['Optuser']['start'] ="";
			else{
				$tmp['Optuser']['start'] = date('H:i', strtotime($record['Optuser']['in_min']));
				$tmp['Optuser']['start_long'] = $record['Optuser']['in_min'];
			}
			if($record['Optuser']['out_max'] == "1000-01-01 00:00:00")
				$tmp['Optuser']['end'] ="";
			else{
				$tmp['Optuser']['end'] = date('H:i', strtotime($record['Optuser']['out_max']));
				$tmp['Optuser']['end_long'] = $record['Optuser']['out_max'];
			}*/
			$tmp['Optuser']['date'] = $record['Optuser']['date'];
			$w = date('w', strtotime($record['Optuser']['date']));
			$tmp['Optuser']['weekday'] = $week[$w];
			
			if($tmp['Optuser']['end'] == ""){
				$hostid = $record['Host']['id'];
				$_start = $record['Optuser']['date']." ".$start;
				$last = $this->Hstactivelog->find(
					"Hstactivelog.host_id = {$hostid} and Hstactivelog.lasttime between '{$_start}' and '{$_start}' + INTERVAL 1 day",
					"max(Hstactivelog.lasttime) as Hstactivelog__maxtime");
				if(isset($last['Hstactivelog']['maxtime'])){
					$max = strtotime($last['Hstactivelog']['maxtime']);
					//echo date('H:i', $max);
					if(strtotime( "now" ) - $max > 300 * 2)//TODO設定した周期
						$tmp['Optuser']['end'] = date('H:i', $max);
				}
					
			}
			
			$data2[] = $tmp;
		}
	
		foreach($data2 as &$record){
			if(empty($record['Optuser']['start']) || empty($record['Optuser']['end']))
				$record['Optuser']['out'] = '○';//true;
			else{
				//一日の開始時刻
				$deftime = $defaults[$record['Employee']['group_id']];

				//就業時間
				$startWork = "";
				$endWork = "";
				if(!empty($deftime['Timecontrol']['start_work']))
					$startWork = $deftime['Timecontrol']['start_work'];
				if(!empty($deftime['Timecontrol']['end_work']))
					$endWork = $deftime['Timecontrol']['end_work'];
				$startstr = date("H:i", strtotime($startWork) );
				$endstr = date("H:i", strtotime($endWork) );
		
				//$time = date('H:i' , strtotime($record['Optuser']['start']));
				//$time2 = date('H:i' , strtotime($record['Optuser']['end']));
				
				$add = 0;
				if($startstr > $endstr)
					$add = 1;
				
				$start = strtotime($record['Optuser']['date']." ".$startstr);
				$end = strtotime($record['Optuser']['date']." ".$endstr.' +'.$add.' days');
				/*
				echo date('Y-m-d H:i:s',$start)."<br/>";
				echo date('Y-m-d H:i:s',$end)."<br/>";
				echo $record['Optuser']['start_long']."<br/>";
				echo $record['Optuser']['end_long']."<br/>";
				*/
				if($start  <= strtotime($record['Optuser']['start_long']) && strtotime($record['Optuser']['end_long']) <= $end)
					$record['Optuser']['out'] = "";//false;
				else
					$record['Optuser']['out'] = '○';//true;
			}
		}
		//debug($this->data);
		if($type=='csv')
		{
			$this->csvdown($data2);exit();
		}		
		
		
		$this->set('data', $data2);

	}
	
	function search($type=null)
	{
		$this->layout="ajax";
		//debug($this->data);
		$group_id = $this->data['Employee']['group_id'];
		$emp_id = $this->data['Employee']['id'];
		//$host_id = $this->data['Host']['id'];
		$host_name = $this->data['Host']['host_name'];
		$host_check = $this->data['Host']['check'];
		
		$criteria[] = "1=1";
		
		//開始時間、時間外の判定
		$defaults = $this->getDefault($group_id);
		//debug($defaults);
		
		$start_date = $this->data['Date']['start'];
		$end_date = $this->data['Date']['end'];
		
		$times = "";
		foreach($defaults as $gid => $def){
			$start = "00:00:00";
			if(!empty($def['Timecontrol']['start_day']))
				$start = $def['Timecontrol']['start_day'];
			
			if($type=='csv2'){
				$time = " Hstactivelog.tslog between '".$start_date." ".$start."' and '".$end_date." ".$start."' + interval 1 day  and (Employee.group_id = ".$gid.")";
				$times .= "(".$time.") or";
				$time = " Hstactivelog.tslog between '".$start_date." ".$start."' and '".$end_date." ".$start."' + interval 1 day  and (Rlthstgrp.group_id = ".$gid.")";
				$times .= "(".$time.") or";
			}else{
				$by_dt = $this->Lv->optionsDatetime4($start);
				$time = implode(' and ', $by_dt)." and (Employee.group_id = ".$gid.")";
				$times .= "(".$time.") or";
				$time = implode(' and ', $by_dt)." and (Rlthstgrp.group_id = ".$gid.")";
				$times .= "(".$time.") or";
			}
			
		}//echo $times;
		$times = rtrim($times, "or"); 
		if(strlen($times) > 0)
			$criteria[] = "(".$times .")";
		else
			$criteria[] = "1=2";
		
		$glist = $this->Grpauth->getChildrenByParent($group_id);
		$group_ids = "";
		foreach($glist as $key => $g){
			$group_ids .= $key.",";
		}
		$group_ids = rtrim($group_ids, ","); 
		//$criteria[] = "Rlthstgrp.group_id in (". $group_ids.") ";
		$criteria[] = "(Employee.group_id in (". $group_ids.") or  Rlthstgrp.group_id in (". $group_ids.") )";

		if(!empty($emp_id))
			$criteria[] = "Employee.id =". $emp_id;
		
		if(!empty($host_name)){
			if($host_check == 0)
				$criteria[] = "Host.host_name = '". $this->Lv->spec_char_dbm($host_name). "'";
			else
				$criteria[] = "Host.host_name like '%". $this->Lv->spec_char_like($host_name). "%'";
		}

		$criteria['GROUP BY'] = "Hstactivelog.host_id, DATE_FORMAT(SUBTIME(Hstactivelog.tslog, '$start'), '%Y%m%d')";
		//Optuser.log_status, 
		$asso = array(
		'Host : hosts' => array('Hstactivelog.host_id = Host.id'),
		'Employeeaccount : employeeaccounts : left' => array('Employeeaccount.host_id = Hstactivelog.host_id'),
		'Employee : employees : left' => array('Employeeaccount.employee_id = Employee.id'),
		'Group : groups : left' => array('Group.id = Employee.group_id'),
		'Rlthstgrp : rlthstgrps' => array('Rlthstgrp.host_id = Host.id'),
		'Group2 : groups' => array('Group2.id = Rlthstgrp.group_id'),
		);
		//date('H:i', strtotime( "now" ));
				
		$fields = array(
		'date(min(Hstactivelog.tslog)) as Optuser__date',
		'min(case when log_status = 1 then Hstactivelog.tslog else "9999-01-01 00:00:00" end) as Hstactivelog__min',
		'max(case when log_status = 1 then Hstactivelog.lasttime else "1000-01-01 00:00:00" end) as Hstactivelog__in_max',
		'max(case when log_status = 2 then Hstactivelog.lasttime else "1000-01-01 00:00:00" end) as Hstactivelog__max',
		'case when Group.group_name is null then Group2.group_name else Group.group_name end as Group__group_name',
		'case when Group.id is null then Group2.id else Group.id end as Group__id',
		'Host.host_name',
		'Employee.id_name',
		'Employee.name',
		'Employeeaccount.account'
		);
		//$this->Pagination->show = 1;//100
		if($type=='csv'||$type=='csv2'){
			$data = $this->Hstactivelog->findByAsso($criteria, $fields, 'Optuser__date, Group__group_name, Employee.id_name', null, null, $asso);
		}else{
			list($order,$limit,$page) = $this->Pagination->init($criteria, null, array('ajaxDivUpdate'=>'search', 'url'=>'/uptime_records/search/', 'modelClass'=>'Hstactivelog', 'queryType' => array('function' => 'findByAsso', 'asso' => $asso), 
			'sortBy' => $this->Lv->sortBy('Optuser__date, Group__group_name, Employee.id_name')));

			$log_count = $this->Pagination->paging['total'];
			$log_limit = 5000;
			$dir=LOG_LIMIT;
			$ini_array = parse_ini_file($dir,true);
			if (!empty($ini_array) && ereg("^[0-9]{1,}$",$ini_array['LogLimit']['Log_timekeeper'])) {
				$log_limit = $ini_array['LogLimit']['Log_timekeeper'];
			}
			if($log_count > $log_limit){
				$this->set('count_err',__("E-03900",true).$log_limit.__("E-03900-1",true));
				$this->render();
				exit();
			}			
						
			$data = $this->Hstactivelog->findByAsso($criteria, $fields, $order, $limit, $page, $asso);

		}
		
		//var_dump($data);
		$data2 = array();
		$week = array("日", "月", "火", "水", "木", "金", "土");
		foreach($data as $record){
			$tmp = $record;
			
			if($record['Hstactivelog']['min'] != "9999-01-01 00:00:00"){
				$tmp['Optuser']['start'] = date('H:i', strtotime($record['Hstactivelog']['min']));
				$tmp['Optuser']['start_long'] = $record['Hstactivelog']['min'];
			}else{
				$tmp['Optuser']['start'] = "";
				$tmp['Optuser']['start_long'] = "";
			}

			if($record['Hstactivelog']['max'] > $record['Hstactivelog']['in_max'])
			{
				$tmp['Optuser']['end'] = date('H:i', strtotime($record['Hstactivelog']['max']));		
				$tmp['Optuser']['end_long'] = $record['Hstactivelog']['max'];
				if($tmp['Optuser']['start'] >= $tmp['Optuser']['end'] && $tmp['Optuser']['start_long'] < $tmp['Optuser']['end_long'])
				{//2000/01/01 05:00 - 2000/01/02 05:00
					$hour = date('G', strtotime($record['Hstactivelog']['max'])) + 24;	
					$min = date('i', strtotime($record['Hstactivelog']['max']));	
					$tmp['Optuser']['end'] = sprintf("%d:%02d", $hour, $min);
				}
			}else{
				$tmp['Optuser']['end'] = "";	
				$tmp['Optuser']['end_long'] = "";
			}
			if($type=='csv'){
				$tmp['Optuser']['start'] = '="'.$tmp['Optuser']['start'].'"';
				$tmp['Optuser']['end'] = '="'.$tmp['Optuser']['end'].'"';
			}

			$tmp['Optuser']['date'] = $record['Optuser']['date'];
			$w = date('w', strtotime($record['Optuser']['date']));
			$tmp['Optuser']['weekday'] = $week[$w];
			
			$data2[] = $tmp;
		}
		if($type=='csv2')
		{
			$this->csvdown2($data2);exit();
		}
	
		foreach($data2 as &$record){
			if(empty($record['Optuser']['start']) || empty($record['Optuser']['end']))
				$record['Optuser']['out'] = '○';//true;
			else{
				//一日の開始時刻
				$deftime = $defaults[$record['Group']['id']];
//var_dump($deftime);
				//就業時間
				$startWork = "";
				$endWork = "";
				if(!empty($deftime['Timecontrol']['start_work']))
					$startWork = $deftime['Timecontrol']['start_work'];
				if(!empty($deftime['Timecontrol']['end_work']))
					$endWork = $deftime['Timecontrol']['end_work'];
				$startstr = date("H:i", strtotime($startWork) );
				$endstr = date("H:i", strtotime($endWork) );
		
				//$time = date('H:i' , strtotime($record['Optuser']['start']));
				//$time2 = date('H:i' , strtotime($record['Optuser']['end']));
				
				$add = 0;
				if($startstr > $endstr)
					$add = 1;
				
				$start = strtotime($record['Optuser']['date']." ".$startstr);
				$end = strtotime($record['Optuser']['date']." ".$endstr.' +'.$add.' days');
			/*	
				echo date('Y-m-d H:i:s',$start)."<br/>";
				echo date('Y-m-d H:i:s',$end)."<br/>";
				echo $record['Optuser']['start_long']."<br/>";
				echo $record['Optuser']['end_long']."<br/>";
				*/
				if($start  <= strtotime($record['Optuser']['start_long']) 
					&& strtotime($record['Optuser']['end_long']) <= $end)
					$record['Optuser']['out'] = "";//false;
				else
					$record['Optuser']['out'] = '○';//true;
			}
		}
		//debug($this->data);
		if($type=='csv')
		{
			$this->csvdown($data2);exit();
		}		
		
		$this->set('data', $data2);

	}
	
	function search2($type=null)
	{
		$this->layout="ajax";
		//debug($this->data);
		$group_id = $this->data['Employee']['group_id'];
		
		$criteria[] = "1=1";
		
		//開始時間、時間外の判定
		$defaults = $this->getDefault($group_id);
		//debug($defaults);
		
		if($type=='csv2'){
			$start_date = $this->data['Date']['start'];
			$end_date = $this->data['Date']['end'];
			
			$times = "";
			foreach($defaults as $gid => $def){
				$start = "00:00:00";
				if(!empty($def['Timecontrol']['start_day']))
					$start = $def['Timecontrol']['start_day'];
				$time = " Hstactivelog.tslog between '".$start_date." ".$start."' and '".$end_date." ".$start."' + interval 1 day  and (Employee.group_id = ".$gid.")";
				$times .= "(".$time.") or";
				$time = " Hstactivelog.tslog between '".$start_date." ".$start."' and '".$end_date." ".$start."' + interval 1 day  and (Rlthstgrp.group_id = ".$gid.")";
				$times .= "(".$time.") or";
			}//echo $times;
			
			$times = rtrim($times, "or"); 
			if(strlen($times) > 0)
				$criteria[] = "(".$times .")";
			else
				$criteria[] = "1=2";
			
		}
		
		$glist = $this->Grpauth->getChildrenByParent($group_id);
		$group_ids = "";
		foreach($glist as $key => $g){
			$group_ids .= $key.",";
		}
		$group_ids = rtrim($group_ids, ","); 
		//$criteria[] = "Rlthstgrp.group_id in (". $group_ids.") ";
		$criteria[] = "(Employee.group_id in (". $group_ids.") or  Rlthstgrp.group_id in (". $group_ids.") )";


		$criteria['GROUP BY'] = "Hstactivelog.host_id, DATE_FORMAT(SUBTIME(Hstactivelog.tslog, '$start'), '%Y%m%d')";
		//Optuser.log_status, 
		$asso = array(
		'Host : hosts' => array('Hstactivelog.host_id = Host.id'),
		'Employeeaccount : employeeaccounts : left' => array('Employeeaccount.host_id = Hstactivelog.host_id'),
		'Employee : employees : left' => array('Employeeaccount.employee_id = Employee.id'),
		'Group : groups : left' => array('Group.id = Employee.group_id'),
		'Rlthstgrp : rlthstgrps' => array('Rlthstgrp.host_id = Host.id'),
		'Group2 : groups' => array('Group2.id = Rlthstgrp.group_id'),
		);
		//date('H:i', strtotime( "now" ));
				
		$fields = array(
		'date(min(Hstactivelog.tslog)) as Optuser__date',
		'min(case when log_status = 1 then Hstactivelog.tslog else "9999-01-01 00:00:00" end) as Hstactivelog__min',
		'max(case when log_status = 1 then Hstactivelog.lasttime else "1000-01-01 00:00:00" end) as Hstactivelog__in_max',
		'max(case when log_status = 2 then Hstactivelog.lasttime else "1000-01-01 00:00:00" end) as Hstactivelog__max',
		'case when Group.group_name is null then Group2.group_name else Group.group_name end as Group__group_name',
		'case when Group.id is null then Group2.id else Group.id end as Group__id',
		'Host.host_name',
		'Employee.id_name',
		'Employee.name',
		'Employeeaccount.account'
		);
		//$this->Pagination->show = 1;//100
		if($type=='csv'||$type=='csv2'){
			$data = $this->Hstactivelog->findByAsso($criteria, $fields, 'Group__group_name, Employee.id_name', null, null, $asso);
		}else{
			list($order,$limit,$page) = $this->Pagination->init($criteria, null, array('ajaxDivUpdate'=>'search', 'url'=>'/uptime_records/search/', 'modelClass'=>'Hstactivelog', 'queryType' => array('function' => 'findByAsso', 'asso' => $asso), 
			'sortBy' => $this->Lv->sortBy('Optuser__date, Group__group_name, Host.host_name')));

			$log_count = $this->Pagination->paging['total'];
			$log_limit = 5000;
			$dir=LOG_LIMIT;
			$ini_array = parse_ini_file($dir,true);
			if (!empty($ini_array) && ereg("^[0-9]{1,}$",$ini_array['LogLimit']['Log_timekeeper'])) {
				$log_limit = $ini_array['LogLimit']['Log_timekeeper'];
			}
			if($log_count > $log_limit){
				$this->set('count_err',__("E-03900",true).$log_limit.__("E-03900-1",true));
				$this->render();
				exit();
			}			
						
			$data = $this->Hstactivelog->findByAsso($criteria, $fields, $order, $limit, $page, $asso);

		}
		
		//var_dump($data);
		$data2 = array();
		$week = array("日", "月", "火", "水", "木", "金", "土");
		foreach($data as $record){
			$tmp = $record;
			
			if($record['Hstactivelog']['min'] != "9999-01-01 00:00:00"){
				$tmp['Optuser']['start'] = date('H:i', strtotime($record['Hstactivelog']['min']));
				$tmp['Optuser']['start_long'] = $record['Hstactivelog']['min'];
			}else{
				$tmp['Optuser']['start'] = "";	
				$tmp['Optuser']['start_long'] = "";
			}

			if($record['Hstactivelog']['max'] > $record['Hstactivelog']['in_max'])
			{
				$tmp['Optuser']['end'] = date('H:i', strtotime($record['Hstactivelog']['max']));		
				$tmp['Optuser']['end_long'] = $record['Hstactivelog']['max'];
				if($tmp['Optuser']['start'] >= $tmp['Optuser']['end'] && $tmp['Optuser']['start_long'] < $tmp['Optuser']['end_long'])
				{//2000/01/01 05:00 - 2000/01/02 05:00
					$hour = date('G', strtotime($record['Hstactivelog']['max'])) + 24;	
					$min = date('i', strtotime($record['Hstactivelog']['max']));	
					$tmp['Optuser']['end'] = sprintf("%d:%02d", $hour, $min);
				}
			}else{
				$tmp['Optuser']['end'] = "";	
				$tmp['Optuser']['end_long'] = "";
			}
	

			$tmp['Optuser']['date'] = $record['Optuser']['date'];
			$w = date('w', strtotime($record['Optuser']['date']));
			$tmp['Optuser']['weekday'] = $week[$w];
			
			$data2[] = $tmp;
		}
		if($type=='csv2')
		{
			$this->csvdown2($data2);exit();
		}
	
		foreach($data2 as &$record){
			if(empty($record['Optuser']['start']) || empty($record['Optuser']['end']))
				$record['Optuser']['out'] = '○';//true;
			else{
				//一日の開始時刻
				$deftime = $defaults[$record['Group']['id']];
//var_dump($deftime);
				//就業時間
				$startWork = "";
				$endWork = "";
				if(!empty($deftime['Timecontrol']['start_work']))
					$startWork = $deftime['Timecontrol']['start_work'];
				if(!empty($deftime['Timecontrol']['end_work']))
					$endWork = $deftime['Timecontrol']['end_work'];
				$startstr = date("H:i", strtotime($startWork) );
				$endstr = date("H:i", strtotime($endWork) );
		
				//$time = date('H:i' , strtotime($record['Optuser']['start']));
				//$time2 = date('H:i' , strtotime($record['Optuser']['end']));
				
				$add = 0;
				if($startstr > $endstr)
					$add = 1;
				
				$start = strtotime($record['Optuser']['date']." ".$startstr);
				$end = strtotime($record['Optuser']['date']." ".$endstr.' +'.$add.' days');
			/*	
				echo date('Y-m-d H:i:s',$start)."<br/>";
				echo date('Y-m-d H:i:s',$end)."<br/>";
				echo $record['Optuser']['start_long']."<br/>";
				echo $record['Optuser']['end_long']."<br/>";
				*/
				if($start  <= strtotime($record['Optuser']['start_long']) 
					&& strtotime($record['Optuser']['end_long']) <= $end)
					$record['Optuser']['out'] = "";//false;
				else
					$record['Optuser']['out'] = '○';//true;
			}
		}
		//debug($this->data);
		if($type=='csv')
		{
			$this->csvdown($data2);exit();
		}		
		
		$this->set('data', $data2);

	}
	
	function aggregate(){
		$this->layout='ajax';
		$glist = $this->Grpauth->getChildrenByParent($this->_getUserGroup());
		ksort($glist);
		$this->set('glist',$glist);
	}
	
	function csvdown($data = array())
	{
		require_once( 'csv/DlFactory.php' );
		$csv = DlFactory::create("uptime_records");
		if(isset($this->data["Employee"]["group_id"])){
			$this->data["Employee"]["group"] = $this->groupName($this->data["Employee"]["group_id"]);
		}
		
		if(isset($this->data["Employee"]["id"])){
			$this->data["Employee"]["id_name"] = $this->employeeName($this->data["Employee"]["id"]);
		}
		if($this->data["Host"]["check"] == 1){
			$this->data["Host"]["check"] = "〇";
		}
			
		$csv->sendCSVFile($data,$this->data, __('record_csv',$return = true));
		exit;
	}
	

	//稼働時間合計
	function csvdown2($data = array())
	{//var_dump($data);return;
		$result = array();
		$info = array();
		foreach($data as $record){
			$result[$record['Host']['host_name']] = 0;
			$in = array();
			$in['Host']['host_name'] = $record['Host']['host_name'];
			$in['Group']['group_name'] = $record['Group']['group_name'];
			$in['Employee']['id_name'] = $record['Employee']['id_name'];
			$in['Employee']['name'] = $record['Employee']['name'];
			$in['Employeeaccount']['account'] = $record['Employeeaccount']['account'];
			$info[$record['Host']['host_name']] = $in;
		}
		
		foreach($data as $record){
			$tmp = $record;
			//echo $record['Optuser']['start']."  ".$record['Optuser']['end'];
			//echo "<br/>";
			if($record['Optuser']['start_long'] != '' && $record['Optuser']['end_long'] != ''){
				$end = strtotime(date("Y/m/d H:i:00", strtotime($record['Optuser']['end_long'])));
				$start = strtotime(date("Y/m/d H:i:00", strtotime($record['Optuser']['start_long'])));
				$diff = $end - $start;
				/*if($diff > 86400){
					$diff = 86400;
				}*/
				$result[$record['Host']['host_name']] += $diff;
			}
		}
		//	var_dump($result);return;
		$data2 = array();
		foreach($result as $key => $rec)
		{
			$d = array();
			$d['Host']['host_name'] = $key;
			$d['Optuser']['sum'] = $this->time_diff_format($rec);
			
			$in = $info[$key];
			$d['Group']['group_name'] = $in['Group']['group_name'];
			
			$d['Employee']['id_name'] = $in['Employee']['id_name'];
			$d['Employee']['name'] = $in['Employee']['name'];
			$d['Employeeaccount']['account'] = $in['Employeeaccount']['account'];
		
			$data2[] = $d;
		}
/*元データがソートされている
			$names0 = array();$names1 = array();$names2 = array();$names3 = array();
			foreach($data as $a => $d){
				$names0[] = $d['Employee']['id_name'];
				$names1[] = $d['Group']['group_name'];
			}
		$sort = SORT_ASC;
		array_multisort($names0, $sort, $names1, $sort, $data2);*/
		//var_dump($data2);return;
		///////////////
		require_once( 'csv/DlFactory.php' );
		$csv = DlFactory::create("uptime_records2");
		if(isset($this->data["Employee"]["group_id"])){
			$this->data["Employee"]["group"] = $this->groupName($this->data["Employee"]["group_id"]);
		}

		$csv->sendCSVFile($data2,$this->data, __('recordsum_csv',$return = true));
		exit;
	}
	
	function time_diff_format($diff) 
	{
		$hour = floor($diff / 3600); 
		$min = floor(($diff - ($hour*3600)) / 60);
		return sprintf("%d:%02d:00", $hour,$min);
	}
	
	function groupName($group_id)
	{
		$criteria=" Group.id=".$group_id." ";
		$group_n= $this->Group->findAll($criteria);
		$group_name = $group_n[0]["Group"]["group_name"];
		return $group_name;
	}
	
	function employeeName($emp_id)
	{
		$criteria[]="Employee.id =".$emp_id;
		$elist = $this->Employee->findAll($criteria, array('concat(Employee.id_name, " ", Employee.name) as Employee__name'), null, null, 1);
		return $elist[0]['Employee']['name'];
	}
	
	//グループの基本設定を取得　無い場合は親の設定を取得
	function getTimecontrol($groupid)
	{
		$default = $this->Timecontrol->find(array("group_id" => $groupid));
		if(empty($default))
		{
			$parent = $this->Group->group_father_id($groupid);
			if(!empty($parent))
				$default = $this->getTimecontrol($parent);
		}
		return $default;
	}
	
	//グループごとの基本設定取得
	function getDefault($parent)
	{
		$glist = $this->Grpauth->getChildrenByParent($parent);
		$defaults = array();
		foreach($glist as $gid => $gname)
		{
			$default = $this->getTimecontrol($gid);
			$defaults[$gid] = $default;
		}
		return $defaults;
	}
}
?>